; routine to add a field to a file
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_keys_ext_thg
*
; add a field with given name and type to the file
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.name  equ     $c      ; name of new field (string or substring)
p.type  equ     $10     ; type of field (key, uword)
; errors
; itnf  invalid bufferid
; orng  fieldtype out of range
; inam  invalid name (null name not excepted)
; fex   fieldname already exists
; drfl  no place for an extra field
cod_ADDF xsub
        regsave d1/d2/a1-a5
s.oldid equ     0       ;old fieldid (.b)
s.len   equ     2
        getssp  s.len
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        move.l  b_file(a4),a4   ; we only need to know the fileid

        ; test if type in range
        moveq   #err.orng,d0    ; assume type out of range
        move.b  p.type+3(a5),d1 ; get the type
        ble     codend          ; null, negative -> forget it
        sub.b   #ft.high+1,d1   ; check it out
        bpl     codend          ; too high -> invalid field type

        ; and make sure a fieldname is given
        ; and put start of name in a2
        ; and length in d2
        moveq   #err.inam,d0    ; assume invalid name
        move.w  p.name-4(a5),d1 ; type of parameter
        beq     codend          ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a2   ; ptr to name
        move.w  (a2)+,d2        ; string length
        beq     codend          ; if zero -> no field to include
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq     codend
        move.w  p.name-2(a5),d2 ; string length
        beq     codend          ; if zero -> no field to include
        move.l  p.name(a5),a2   ; ptr to name
codcps

        ; check if name is not too long
        cmp.w   #16,d2          ; check that name is not too long
        bmi.s   codlok          ; not too long
        move.w  #16,d2          ; name max 16 chars
codlok
        ; now we have to go in SuperVisor for safety
        mutex
        ; check out if there is a field with the same name
        xjsr    get_idfi        ; get field with this name (parameters a2,a4,d2 are set)
        bmi.s   namok           ; if we can't find it, it isn't used
        moveq   #err.fex,d0     ; oops, already exists
        bra.s   ahum
namok
        ; find a suitable fieldid
        move.b  f_lstfid(a4),s.oldid(sp); fill in the old id to prevent infinite loop
        moveq   #err.drfl,d0    ; assume there is no place (drive full)
nxtid   addq.b  #1,f_lstfid(a4) ; add one
        moveq   #0,d1
        move.b  f_lstfid(a4),d1 ; get the 'hopefully' new fileid
        cmp.b   s.oldid(sp),d1  ; do we have to stop ?
        beq.s   ahum
        mulu    #18,d1          ; get offset in fieldlist
        add.l   #f_fields,d1    ; add affset of this list in filedata
        tst.w   0(a4,d1.w)      ; is it unused ? (type end namelength =0)
        bne.s   nxtid           ; no -> try the next one

        ; fill in the fieldname and type
        lea     0(a4,d1.w),a3   ; start of fielddata for this field
        move.b  p.type+3(a5),(a3)+      ; fill in the fieldtype
        move.b  d2,(a3)+        ; fill in length
        subq.w  #1,d2           ; prepare for dbf
codcpy  move.b  (a2)+,(a3)+     ; copy a char
        dbf     d2,codcpy       ; and the next one ?...
        moveq   #0,d0

        ; if this file is disk-based, then we have to save the fielddata back to disk
        tst.b   f_file(a4)
        beq.s   ahum            ; memory-based -> done
        move.l  f_chid(a4),a0   ; channelid
        move.l  #26+512,d1
        xjsr    iof_posa        ; position file
        bne.s   ahum
        move.l  #4608,d2        ; nr of bytes to send
        lea     f_fields(a4),a1 ; start of buffer
        xjsr    iob_smul        ; send field-data
        bne.s   ahum
        endmutex
        xjsr    iof_flsh        ; flush buffers
        bra.s   codend
ahum    endmutex
codend
        subend
;
        end
