; delete the record in the buffer
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
*
; delete the record in the buffer
; the record will be removed from the file, but will remain in the buffer
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
; errors
; rdo   sorry, this is a read only buffer
; any file i/o error
cod_DELE xsub
        regsave d1-d4/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        moveq   #err.rdo,d0     ; assume we can't write on this buffer
        tst.b   b_view(a4)      ; check it out
        bne.s   codend          ; you see ...

        moveq   #0,d0
        tst.b   b_new(a4)       ; was this a new one ?
        bne.s   codend          ; yes -> isn't in the file

        ; now delete the record
        mutex                   ; hey, we don't want no mixup
        ; now we have to link out the record
        ; linkout is recursive routine to link a record out
        ; ptr to list: on stack, d4 recordid, d2 boolean
        move.l  b_file(a4),a3
        lea     f_top(a3),a0
        move.l  b_id(a4),d4
        move.l  a0,-(sp)        ; head pointer of tree
        moveq   #0,d2           ; start with false
        jsr     linkout
        adda.w  #4,sp           ; clean up stack
        moveq   #0,d0
ahum    endmutex
        tst.b   f_file(a3)      ; disk-based?
        beq.s   codend
        move.l  f_chid(a3),a0   ; channel id
        xjsr    iof_flsh        ; flush buffers
codend
        subend

; linkout is recursive routine to link a record out
; addr of ptr to list: on stack, d4 recordid to unlink, d2 boolean (false at start)
; based on verwijder routine in "Algoritmen en datastructuren" p289
; can corrupt a0-a2/d0-d3
p.ptr   equ     $4              ; place, relative to stack where we can find the head ptr of the tree
linkout
        move.l  p.ptr(sp),a0    ; ptr to head ptr
        tst.l   (a0)            ; zero ?
        beq     elink           ; yes -> nothing to unlink
        move.l  (a0),a0         ; current linkage
        cmp.l   rl_id(a0),d4    ; compare id
        bge.s   right
        lea     rl_left(a0),a0
        move.l  a0,-(sp)        ; head pointer of tree (left branche)
        jsr     linkout         ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp           ; clean up stack
        move.l  p.ptr(sp),a0    ; and restore pointer
        move.l  (a0),a0         ; to value as at the start
        tst.b   d2              ; has there been any growth ?
        beq     elink           ; no -> in balance
        bsr     balansL         ; breng links in balans
        move.l  p.ptr(sp),a1
        move.l  a0,(a1)
        rts
right   cmp.l   rl_id(a0),d4    ; compare id
        ble.s   equal
        lea     rl_right(a0),a0
        move.l  a0,-(sp)        ; head pointer of tree (left branche)
        jsr     linkout         ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp           ; clean up stack
        move.l  p.ptr(sp),a0    ; and restore pointer
        move.l  (a0),a0         ; to value as at the start
        tst.b   d2              ; has there been any growth ?
        beq     elink           ; no -> in balance
        bsr     balansR         ; breng links in balans
        move.l  p.ptr(sp),a1
        move.l  a0,(a1)
        rts
equal   move.l  p.ptr(sp),a1
        tst.l   rl_right(a0)
        bne.s   eq1
        move.l  rl_left(a0),(a1)
        moveq   #1,d2
        bra.s   rel
eq1     tst.l   rl_left(a0)
        bne.s   eq2
        move.l  rl_right(a0),(a1)
        moveq   #1,d2
        bra.s   rel
eq2     move.l  a0,-(sp)        ; keep p for a while, and use q
        move.l  rl_left(a0),a1
        bsr     weg
        move.l  a0,d0           ; beware, q may have changed
        move.l  (sp)+,a0        ; we we need to set it in the old one
        move.l  a1,rl_left(a0)
        move.l  d0,-(sp)        ; this is the one we will have to release
        tst.b   d2
        beq.s   rel2
        bsr     balansL         ; breng links in balans
        move.l  p.ptr+4(sp),a1
        move.l  a0,(a1)
rel2    move.l  (sp)+,a0
rel     ; release the record with record linkage in a0
        move.l  f_free(a3),(a0) ; link into free record linkages
        move.l  a0,f_free(a3)
        move.l  #-1,rl_id(a0)   ; unused linkage
        move.l  rl_pos(a0),a0   ; position of record
        tst.b   f_file(a3)      ; disk-based ??
        bne.s   relfile         ; yep -> release on file
        xjsr    relmem
        ; and we have one less record in the file
        subq.l  #1,f_count(a3)
        move.b  #1,b_new(a4)    ; record in buffer is new again
        rts
relfile ; we have to clear the record area to zero
        move.l  a0,d1           ; start of record
        move.l  d1,d3
        addi.l  #10,d1          ; skip 'R'.b,mark.b,id.l,date.l
        move.l  f_chid(a3),a0   ; channel id
        xjsr    iof_posa        ; position file pointer
        bne.s   elink           ; ahum...
        ; read record length
        moveq   #0,d2           ; clear record len
        xjsr    iob_fbyt
        bne.s   elink
        move.b  d1,d2
        xjsr    iob_fbyt
        bne.s   elink
        lsl.l   #8,d2
        move.b  d1,d2
        xjsr    iob_fbyt
        bne.s   elink
        lsl.l   #8,d2
        move.b  d1,d2
        xjsr    iob_fbyt
        bne.s   elink
        lsl.l   #8,d2
        move.b  d1,d2
        ; so old record len in in d2
        add.l   #14,d2          ; add record length
        move.l  d3,d1           ; start of record
        xjsr    iof_posa        ; position file pointer
        bne.s   elink           ; oops
        ; and clear it
        moveq   #0,d1           ; byte to send
f_cllp
        xjsr    iob_sbyt        ; send a byte
        bne.s   elink           ; oops
        subq.l  #1,d2           ; another one ?
        bgt.s   f_cllp
        ; and we have one less record in the file
        subq.l  #1,f_count(a3)
        move.b  #1,b_new(a4)
elink   rts                     ; and that's it

weg     ; parameters a1 ptr, d2 boolean
        tst.l   rl_right(a1)
        beq.s   weg1
        move.l  a1,-(sp)
        move.l  rl_right(a1),a1
        bsr     weg
        move.l  a1,d1
        move.l  (sp)+,a1
        move.l  d1,rl_right(a1)
        tst.b   d2
        beq.s   weg2
        exg     a0,a1
        move.l  a1,-(sp)        ; we have to reserve a1
        bsr     balansR         ; breng links in balans
;        move.l  a0,(a2)
        move.l  (sp)+,a1
        exg     a0,a1
        rts
weg1    move.l  rl_id(a1),rl_id(a0)
        move.b  rl_edit(a1),rl_edit(a0)
        move.l  rl_pos(a0),d1   ; keep pos for releasing
        move.l  rl_pos(a1),rl_pos(a0)
        move.l  d1,rl_pos(a1)   ; exchange them
        move.l  a1,a0
        move.l  rl_left(a1),a1
        moveq   #1,d2
weg2    rts

balansL ; returns in a1, the new value for p
        ; so a1 -> (p.ptr(sp))
        tst.b   rl_avl(a0)
        beq.s   bL0
        bpl.s   bL1
        clr.b   rl_avl(a0)
        rts
bL0     move.b  #1,rl_avl(a0)
        moveq   #0,d2
        rts
bL1     ; herbalanceren
        move.l  rl_right(a0),a1
        move.b  rl_avl(a1),d0
        bmi.s   RL
        ; enkelvoudig RR roteren
        move.l  rl_left(a1),rl_right(a0)
        move.l  a0,rl_left(a1)
        tst.b   d0
        bne.s   RRel
        move.b  #1,rl_avl(a0)
        move.b  #-1,rl_avl(a1)
        moveq   #0,d2
        bra.s   RRen
RRel    move.b  #0,rl_avl(a0)
        move.b  #0,rl_avl(a1)
RRen    move.l  a1,a0
        rts
RL      ; dubbel RL roteren
        move.l  rl_left(a1),a2
        move.b  rl_avl(a2),d1
        move.l  rl_right(a2),rl_left(a1)
        move.l  a1,rl_right(a2)
        move.l  rl_left(a2),rl_right(a0)
        move.l  a0,rl_left(a2)
        tst.b   d1
        ble.s   RLel1
        move.b  #-1,rl_avl(a0)
        bra.s   RLen1
RLel1   clr.b   rl_avl(a0)
RLen1   tst.b   d1
        bpl.s   RLel2
        move.b  #1,rl_avl(a1)
        bra.s   RLen2
RLel2   clr.b   rl_avl(a1)
RLen2   clr.b   rl_avl(a2)
        move.l  a2,a0
        rts

balansR ; returns in a1, the new value for p
        ; so a1 -> (p.ptr(sp))
        tst.b   rl_avl(a0)
        beq.s   bR0
        bmi.s   bR_1
        clr.b   rl_avl(a0)
        rts
bR0     move.b  #-1,rl_avl(a0)
        moveq   #0,d2
        rts
bR_1    ; herbalanceren
        move.l  rl_left(a0),a1
        move.b  rl_avl(a1),d0
        bgt.s   LR
        ; enkelvoudig LL roteren
        move.l  rl_right(a1),rl_left(a0)
        move.l  a0,rl_right(a1)
        tst.b   d0
        bne.s   LLel
        move.b  #-1,rl_avl(a0)
        move.b  #1,rl_avl(a1)
        moveq   #0,d2
        bra.s   LLen
LLel    move.b  #0,rl_avl(a0)
        move.b  #0,rl_avl(a1)
LLen    move.l  a1,a0
        rts
LR      ; dubbel LR roteren
        move.l  rl_right(a1),a2
        move.b  rl_avl(a2),d1
        move.l  rl_left(a2),rl_right(a1)
        move.l  a1,rl_left(a2)
        move.l  rl_right(a2),rl_left(a0)
        move.l  a0,rl_right(a2)
        tst.b   d1
        bpl.s   LRel1
        move.b  #1,rl_avl(a0)
        bra.s   LRen1
LRel1   clr.b   rl_avl(a0)
LRen1   tst.b   d1
        ble.s   LRel2
        move.b  #-1,rl_avl(a1)
        bra.s   LRen2
LRel2   clr.b   rl_avl(a1)
LRen2   clr.b   rl_avl(a2)
        move.l  a2,a0
        rts
;
        end
