; routine to get a long from a field of longs
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
        include ram1_inc_keys_err
*
; get a long from a field of longs
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.place equ     $c      ; array element to put is
p.ret   equ     $14     ; return character (ret+long)
; errors
; itnf  buffer id invalid
;       or field not present in this record
; ipar  fieldid doesn't exist
;       field has wrong type
; orng  place has to be >=1, but may not exist
cod_GLNG xsub
        regsave d1/d2/d7/a0/a1/a3-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2
        move.l  b_file(a4),a3   ; we need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.w  d2,d1
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        ; fieldtype ok ?
        cmpi.b  #ft.long,(a3)
        bne.s   codend

        ; check place to fill it in
        moveq   #err.orng,d0    ; assume not
        move.l  p.place(a5),d7  ; place to fill in
        ble.s   codend
        add.l   d7,d7           ; length of a short
        bmi.s   codend
        add.l   d7,d7           ; length of a long
        bmi.s   codend

        ; so try to find this field
        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        xjsr    findfld         ; find it
        bne.s   codend          ; oops, not found

        ; make sure field is long enough to extract the requested data
        moveq   #err.orng,d0    ; assume problems
        cmp.l   rf_len(a1),d7   ; compare
        bgt.s   codend          ; oops
        moveq   #0,d0           ; so -> no problem

        move.l  p.ret(a5),a0
        move.l  rf_fld-4(a1,d7.l),(a0)
codend
        subend
;
        end
