; get the length of a line in a text field
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
        include ram1_inc_keys_err
        include ram1_inc_keys_k
        include ram1_inc_keys_ext_thg
*
; get the length of a line in a text field
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.line  equ     $c      ; line to fill in
p.ret   equ     $14     ; return length (ulong)
; errors
; itnf  buffer id invalid
;       or field not present
;       or line not present
; ipar  fieldid doesn't exist
;       field has wrong type
; orng  line has to be >=1, but has to exist
cod_LENS xsub
        regsave d1/d2/d7/a0/a1/a3-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2         ; amke sure it is word long
        move.l  b_file(a4),a3   ; we need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.w  d2,d1           ; fieldid
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        ; fieldtype ok ?
        cmpi.b  #ft.text,(a3)
        bne.s   codend

        ; check line to fill it in
        moveq   #err.orng,d0    ; assume not
        move.l  p.line(a5),d7   ; line to fill in
        ble.s   codend

        ; so try to find this field
        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        xjsr    findfld         ; find it
        bne.s   codend          ; oops, not found

        ; and the correct line
        moveq   #err.itnf,d0
        move.l  rf_len(a1),d1   ; length of field
        lea     rf_fld(a1),a0   ; actual start of field
        subq.l  #1,d7           ; one less nl to search
        beq.s   eflin           ; nothing to search ->
flin    subq.l  #1,d1           ; check another byte
        bmi.s   codend          ; end reached -> can't find line
        cmpi.b  #k.nl,(a0)+     ; reached the end of a line ?
        bne.s   flin
        subq.l  #1,d7           ; is this the line we need
        bgt.s   flin            ; no -> search next line
eflin
        ; a0 is now the start of the line we want
        move.l  a0,a3           ; keep it, a0 will be preserved
        moveq   #-1,d2          ; length of line
flen    addq.l  #1,d2           ; line is one longer
        subq.l  #1,d1           ; check another byte
        bmi.s   gotlen          ; end reached -> this is the line end
        cmpi.b  #k.nl,(a3)+     ; reached the end of a line ?
        bne.s   flen
gotlen  ; the line length is now in d2, start of line in a0
        move.l  p.ret(a5),a1    ; place to fill in return
        move.l  d2,(a1)         ; fillin
        moveq   #0,d0
codend  subend
;
        end
