; stop useing a certain buffer
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_qdos_ioa
*
; stop useing a certain buffer
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
; errors
cod_UNUS xsub
        regsave d1/a0-a5
        bra.s   start
        xdef    unuse
unuse
        regsave d1/a0-a5        ; stop using a buffer with bufferid
        bra.s   unus            ; passed in a4

start   move.l  p.id(a1),d0     ; buffer id if passed
        tst.w   p.id-4(a1)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error
unus
        move.l  b_file(a4),a3   ; also get fileid

        xjsr    NEWR

        ; close channel for SAVErec if present
        move.l  b_chid(a4),d0   ; channel id, zero for no save rec. seq.
        beq.s   noclos          ; don't close
        move.l  d0,a0           ; channel to close
        moveq   #ioa.clos,d0    ; close channel
        trap    #do.ioa
noclos
        ; unlink buffer from file
        move.l  a4,a2           ; item to unlink
        lea     f_buffer(a3),a1 ; start of list
        xjsr    unlink

        ; release record buffer
        move.l  b_mem(a4),a0    ; start of record buffer
        xjsr    relmem          ; release it

        ; release all indexes for this buffer
        move.l  b_index(a4),d1  ; start of index list
        beq.s   noindex
indexlp move.l  d1,a5           ; get it
        rellist i_area(a5)      ; release mem area list
        ; release index itself
        move.l  a5,a0
        move.l  i_next(a5),d1
        xjsr    relmem
        ; and take next index
        tst.l   d1
        bne     indexlp
noindex
        ; now release the file-buffer
        move.l  a4,a0
        xjsr    relmem

        ; unlink the file
        move.l  a3,d0           ; fid to unlink
        xjsr    unlnkfid        ; do it
        bmi.s   endit           ; not succeeded -> were done

        ; now release all data in the file
        ; first run through the records to release the record buffers
        ; we do this by running through all areas and releasing all records
        ; (recordlinkage with recordid <>-1)
        tst.b   f_file(a3)
        bne.s   clos            ; file-based -> don't release records
        move.l  f_area(a3),d1   ; place in list of areas
        beq.s   clos            ; no records to release -> ..
arealp  move.l  d1,a5
        moveq   #99,d7          ; nr of linkages to run through
        lea     4(a5),a4        ; first record linkage
nxtrl   cmpi.l  #-1,rl_id(a4)   ; linkage used ??
        beq.s   endrl

        ; release it
        move.l  rl_pos(a4),a0   ; record position
        xjsr    relmem

endrl   adda.w  #rl.len,a4      ; start of next linkage
        dbf     d7,nxtrl

        move.l  (a5),d1         ; next area ??
        bne     arealp          ; if there is one
clos
        ; and now release these memory areas
        rellist f_area(a3)      ; release mem area list

        ; close the channel (if disk based)
        tst.b   f_file(a3)      ; file based ?
        beq.s   nofile          ; no -> we don't have to close it
        move.l  f_chid(a3),a0   ; channel id
        moveq   #ioa.clos,d0
        trap    #do.ioa         ; do it
nofile
        ; release file itself
        move.l  a3,a0           ; and the file
        xjsr    relmem

endit   moveq   #0,d0           ; no error
codend  subend
;
        end
