; header file voor de DATAdesign.engine
; (c) 1992 Joachim Van der Auwera voor PROGS
; b_ buffer data                ; f_ file data
; i_ index data                 ; r_ record
; rl_ record link in tree       ; il_ index link in tree
; rf_ a field                   ; c.. compare bit values
        nolist

; record in memory
r_id     equ    0       .l ;recordid
r_mark   equ    4       .b ;mark status for this record
r_empty  equ    5       .b ;UNUSED
r_len    equ    6       .l ;record length exclusive header
r_space  equ    10      .l ;max recordlength to fit this area
r_date   equ    14      .l ;date of last change (QL clock)
r_fld    equ    18         ; start of fields

; field
rf_id    equ    0       .b ;fieldid
rf_empty equ    1       .b ;UNUSED
rf_len   equ    2       .l ;length of field (bytes)
rf_fld   equ    6          ;contents of field

; field types (have to be in the same order as the size of the equivalent data type)
ft.raw   equ    1       ; raw data (unsortable) (list of .b)
ft.text  equ    2       ; text field (list of .b, special char NL)
ft.char  equ    2       ; char field (same as text field)
ft.short equ    3       ; short integer (2.b) (signed)
ft.long  equ    4       ; long integer (4.b) (signed)
ft.ieee  equ    5       ; IEEE double (8.b)
ft.high equ     5       ; highest value for fieldtype

; record linkage in tree
rl_left  equ    0       .l ;ptr to left brache or leaf
rl_next  equ    rl_left .l ;ptr to next free link
rl_right equ    4       .l ;ptr to right brache or leaf
rl_avl   equ    8       .b ;balans for avl
rl_edit  equ    9       .b ;set when this record is being edited (present in a buffer)
rl_id    equ    10      .l ;recordid
rl_pos   equ    14      .l ;ptr to rec(mem) or filepointer(disk)
rl.len  equ     18
rl.100  equ     1804    ; area for 100 record linkages and the link ptr

; index linkage in tree
il_left  equ    0       .l ;ptr to left brache or leaf
il_next  equ    il_left .l ;ptr to next free link
il_right equ    4       .l ;ptr to right brache or leaf
il_avl   equ    8       .b ;balans for avl
il_unus  equ    9       .b ;UNUSED
il_id    equ    10      .l ;recordid (used for compare in case rest equal)
il_index equ    14      i_len.w ;for searching (first level index), and sorting
il.len  equ     14      nominal length, should add 2*i_len

; index data
i_next   equ    0       .l ;ptr to next index for this buffer
i_flag   equ    4       16 ;flag denoting this is an index, contains 'DATAdesign index'
i_top    equ    20      .l ;ptr to top of tree with index
i_free   equ    24      .l ;list of free links in array
i_area   equ    28      .l ;ptr to list of mem areas with arrays of linkages
i_count  equ    32      .l ;total nr of records in this index
i_buffer equ    36      .l ;buffer id of buffer used by this index
i_len    equ    40      .w ;nr of words to compare
i_name   equ    42      34 ;name of index
i_device equ    76      34 ;device of index
i_sort   equ    110     ; start of sort data
i_cmp   equ     0       ; .w compare for this sort level
i_fti   equ     2       ; .b field type (filled in when starting to sort or rebuild)
                        ; special fieldtypes for figuring out how to copy the data
i_fld   equ     3       ; .b field
i_plc   equ     4       ; .w place in field (array element or line)
i.slen  equ     6
i_filt  equ     170     ; start of filter data
i_fcmp  equ     0       ; .w compare for this level
i_ffti  equ     2       ; .b special fieldtype
i_ffld  equ     3       ; .b field
i_fplc  equ     4       ; .w place in field (char fields, 0 to test all elements)
i_fval  equ     6       ; 8.b, value to compare
i.flen  equ     14
; sort data is 10x6 bytes as above
; filter data is 10x14 bytes as above
i.len   equ     110+60+140

; buffer data
b_next   equ    0       .l ;ptr to next buffer for this file
b_flag   equ    4       16 ;flag denoting this is a buffer, contains 'DATAdesign buffr'
b_index  equ    20      .l ;ptr to top of list of indexes
b_dindex equ    24      .l ;id of default index for this buffer
b_dfield equ    28      .b ;id of default field for this buffer
b_new    equ    29      .b ;are we editing a new record ??
b_file   equ    30      .l ;fileid of file used by this buffer
b_mem    equ    34      .l ;ptr to area used to edit the record
b_mlen   equ    38      .l ;length of area used to edit the record
b_id     equ    42      .l ;id of record we are editing
b_rlen   equ    46      .l ;length of record we are editing
b_view   equ    50      .b ;is this a read only buffer?
b_change equ    51      .b ;set if something has changed in this record
b_jobid  equ    52      .l ;id of job using this buffer
b_chid   equ    56      .l ;channel id which is used for partial saving of a file
b_mark   equ    60      .b ; mark status for current record
b_empty  equ    61      .b ;UNUSED
b.len   equ     62

; file data
f_next   equ    0       .l ;ptr to next file in list
f_flag   equ    4       16 ;flag denoting this is a file, contains 'DATAdesign file '
f_empty  equ    20      .l ;UNUSED
f_buffer equ    24      .l ;ptr to first buffer in list which uses this file
f_top    equ    28      .l ;ptr to top of tree with index
f_free   equ    32      .l ;list of free links in array
f_area   equ    36      .l ;ptr to list of mem areas with arrays of linkages
f_count  equ    40      .l ;total nr of records in this index
f_lstrid equ    44      .l ;recordid which was last used
f_lstfid equ    48      .b ;fieldid which was last used
f_file   equ    49      .b ;is this one file based?
f_irsp   equ    50      .w ;inter record space
f_chid   equ    52      .l ;channel id for file based
f_name   equ    56      34 ;name of file
f_device equ    f_name+34  ;device of file
f_order1 equ    f_device+34     ; alphanumerical order, normal (256.b)
f_order2 equ    f_order1+256    ; alphanumerical reverse order, normal
f_order3 equ    f_order2+256    ; alphanumerical order, used for case independance
f_order4 equ    f_order3+256    ; alphanumerical order, used for case independance, reverse
f_fields equ    f_order4+256    ;per veld 18 bytes, eerst type.b, len.b, naam
f.len   equ     f_fields+4608   ; f_fields + 18 * 256

; compare values
; for SORT
c..mark equ     00      ; mark records if equal (mark value 255)
c..date equ     01      ; sort by date (not yet implemented)
c..line equ     02      ; place is a line number
c..text equ     03      ; sort as text
c..case equ     04      ; case dependant (if c..text set)
c..rvrs equ     05      ; reverse order
; for FILT (for filt raw fields are considered the same as char)
;c..mark equ    00      ; compare mark status
;c..date equ    01      ; compare recorddate (not yet implemented)
c..and  equ     02      ; AND (bit set) or OR (bit clear) status to prev levels
c..empty equ    03      ; the field has to be empty (clear) (or not when c..not)
;c..case equ    04      ; case dependant (char field only)
c..not  equ     05      ; not (char field only, or in combination with c..empty)
c..equ  equ     06      ; value in field has to be equal (not char/raw field)
c..smal equ     07      ; value in field has to be smaller (not char/raw field)
c..larg equ     08      ; value in field has to be larger (not char/raw field)
                        ; these three levels can be combined to allow
                        ; smaller OR larger (= not equal)
                        ; smaller OR equal (= not larger) ...
c..str  equ     09      ; compare as string (all chars in given order)
; for Find STRing/INTeger/DouBLE
c..agai equ     00      ; don't search from start (resp. end) of file
;c..case equ    04      ; case dependant (STRing search only)
;c..rvrs equ    05      ; reverse order (search backwords)
        list
